diff -ruN vdr-1.5.2/config.c vdr-1.5.3/config.c
--- vdr-1.5.2/config.c	2007-02-25 14:58:45.000000000 +0100
+++ vdr-1.5.3/config.c	2007-06-02 13:21:40.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.c 1.150 2007/02/25 13:58:45 kls Exp $
+ * $Id: config.c 1.151 2007/06/02 11:21:40 kls Exp $
  */
 
 #include "config.h"
@@ -264,6 +264,13 @@
   OSDHeight = 486;
   OSDMessageTime = 1;
   UseSmallFont = 1;
+  AntiAlias = 1;
+  strcpy(FontOsd, "arialbd.ttf");
+  strcpy(FontSml, "arial.ttf");
+  strcpy(FontFix, "courbd.ttf");
+  FontOsdSize = 22;
+  FontSmlSize = 18;
+  FontFixSize = 20;
   MaxVideoFileSize = MAXVIDEOFILESIZE;
   SplitEditedFiles = 0;
   MinEventTimeout = 30;
@@ -427,6 +434,13 @@
   else if (!strcasecmp(Name, "OSDHeight"))         { OSDHeight          = atoi(Value); if (OSDHeight < 100) OSDHeight *= 27; }
   else if (!strcasecmp(Name, "OSDMessageTime"))      OSDMessageTime     = atoi(Value);
   else if (!strcasecmp(Name, "UseSmallFont"))        UseSmallFont       = atoi(Value);
+  else if (!strcasecmp(Name, "AntiAlias"))           AntiAlias          = atoi(Value);
+  else if (!strcasecmp(Name, "FontOsd"))             strn0cpy(FontOsd, Value, MAXFONTNAME);
+  else if (!strcasecmp(Name, "FontSml"))             strn0cpy(FontSml, Value, MAXFONTNAME);
+  else if (!strcasecmp(Name, "FontFix"))             strn0cpy(FontFix, Value, MAXFONTNAME);
+  else if (!strcasecmp(Name, "FontOsdSize"))         FontOsdSize        = atoi(Value);
+  else if (!strcasecmp(Name, "FontSmlSize"))         FontSmlSize        = atoi(Value);
+  else if (!strcasecmp(Name, "FontFixSize"))         FontFixSize        = atoi(Value);
   else if (!strcasecmp(Name, "MaxVideoFileSize"))    MaxVideoFileSize   = atoi(Value);
   else if (!strcasecmp(Name, "SplitEditedFiles"))    SplitEditedFiles   = atoi(Value);
   else if (!strcasecmp(Name, "MinEventTimeout"))     MinEventTimeout    = atoi(Value);
@@ -497,6 +511,13 @@
   Store("OSDHeight",          OSDHeight);
   Store("OSDMessageTime",     OSDMessageTime);
   Store("UseSmallFont",       UseSmallFont);
+  Store("AntiAlias",          AntiAlias);
+  Store("FontOsd",            FontOsd);
+  Store("FontSml",            FontSml);
+  Store("FontFix",            FontFix);
+  Store("FontOsdSize",        FontOsdSize);
+  Store("FontSmlSize",        FontSmlSize);
+  Store("FontFixSize",        FontFixSize);
   Store("MaxVideoFileSize",   MaxVideoFileSize);
   Store("SplitEditedFiles",   SplitEditedFiles);
   Store("MinEventTimeout",    MinEventTimeout);
diff -ruN vdr-1.5.2/config.h vdr-1.5.3/config.h
--- vdr-1.5.2/config.h	2007-03-03 16:39:05.000000000 +0100
+++ vdr-1.5.3/config.h	2007-06-02 13:22:17.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 1.288 2007/03/03 15:39:05 kls Exp $
+ * $Id: config.h 1.290 2007/06/02 11:22:17 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -17,12 +17,13 @@
 #include <time.h>
 #include <unistd.h>
 #include "i18n.h"
+#include "font.h"
 #include "tools.h"
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.5.2"
-#define VDRVERSNUM   10502  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.5.3"
+#define VDRVERSNUM   10503  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
@@ -242,6 +243,13 @@
   int OSDLeft, OSDTop, OSDWidth, OSDHeight;
   int OSDMessageTime;
   int UseSmallFont;
+  int AntiAlias;
+  char FontOsd[MAXFONTNAME];
+  char FontSml[MAXFONTNAME];
+  char FontFix[MAXFONTNAME];
+  int FontOsdSize;
+  int FontSmlSize;
+  int FontFixSize;
   int MaxVideoFileSize;
   int SplitEditedFiles;
   int MinEventTimeout, MinUserInactivity;
diff -ruN vdr-1.5.2/device.c vdr-1.5.3/device.c
--- vdr-1.5.2/device.c	2007-01-13 13:05:00.000000000 +0100
+++ vdr-1.5.3/device.c	2007-04-30 11:34:00.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 1.139 2007/01/13 12:05:00 kls Exp $
+ * $Id: device.c 1.140 2007/04/30 09:34:00 kls Exp $
  */
 
 #include "device.h"
@@ -327,7 +327,7 @@
              // difference, because it results in the most significant bit of the result.
              uint32_t imp = 0;
              imp <<= 1; imp |= LiveView ? !device[i]->IsPrimaryDevice() || ndr : 0;                                  // prefer the primary device for live viewing if we don't need to detach existing receivers
-             imp <<= 1; imp |= !device[i]->Receiving() || ndr;                                                       // use receiving devices if we don't need to detach existing receivers
+             imp <<= 1; imp |= !device[i]->Receiving() && (device[i] != cTransferControl::ReceiverDevice() || device[i]->IsPrimaryDevice()) || ndr; // use receiving devices if we don't need to detach existing receivers, but avoid primary device in local transfer mode
              imp <<= 1; imp |= device[i]->Receiving();                                                               // avoid devices that are receiving
              imp <<= 1; imp |= device[i] == cTransferControl::ReceiverDevice();                                      // avoid the Transfer Mode receiver device
              imp <<= 8; imp |= min(max(device[i]->Priority() + MAXPRIORITY, 0), 0xFF);                               // use the device with the lowest priority (+MAXPRIORITY to assure that values -99..99 can be used)
diff -ruN vdr-1.5.2/dvbplayer.c vdr-1.5.3/dvbplayer.c
--- vdr-1.5.2/dvbplayer.c	2006-04-17 14:45:48.000000000 +0200
+++ vdr-1.5.3/dvbplayer.c	2007-04-28 16:55:22.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbplayer.c 1.45 2006/04/17 12:45:48 kls Exp $
+ * $Id: dvbplayer.c 1.46 2007/04/28 14:55:22 kls Exp $
  */
 
 #include "dvbplayer.h"
@@ -402,8 +402,10 @@
                        bool TimeShiftMode = index->IsStillRecording();
                        int Index = index->GetNextIFrame(readIndex, playDir == pdForward, &FileNumber, &FileOffset, &Length, TimeShiftMode);
                        if (Index >= 0) {
-                          if (!NextFile(FileNumber, FileOffset))
+                          if (!NextFile(FileNumber, FileOffset)) {
+                             readIndex = Index;
                              continue;
+                             }
                           }
                        else {
                           if (!TimeShiftMode && playDir == pdForward) {
diff -ruN vdr-1.5.2/eit.c vdr-1.5.3/eit.c
--- vdr-1.5.2/eit.c	2006-10-09 18:14:36.000000000 +0200
+++ vdr-1.5.3/eit.c	2007-06-10 14:51:05.000000000 +0200
@@ -8,7 +8,7 @@
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  * Adapted to 'libsi' for VDR 1.3.0 by Marcel Wiesweg <marcel.wiesweg@gmx.de>.
  *
- * $Id: eit.c 1.122 2006/10/09 16:14:36 kls Exp $
+ * $Id: eit.c 1.123 2007/06/10 12:51:05 kls Exp $
  */
 
 #include "eit.h"
@@ -188,6 +188,7 @@
                     if (hit) {
                        char linkName[ld->privateData.getLength() + 1];
                        strn0cpy(linkName, (const char *)ld->privateData.getData(), sizeof(linkName));
+                       // TODO is there a standard way to determine the character set of this string?
                        cChannel *link = Channels.GetByChannelID(linkID);
                        if (link != channel) { // only link to other channels, not the same one
                           //fprintf(stderr, "Linkage %s %4d %4d %5d %5d %5d %5d  %02X  '%s'\n", hit ? "*" : "", channel->Number(), link ? link->Number() : -1, SiEitEvent.getEventId(), ld->getOriginalNetworkId(), ld->getTransportStreamId(), ld->getServiceId(), ld->getLinkageType(), linkName);//XXX
@@ -218,7 +219,7 @@
                  if (1 <= Stream && Stream <= 2 && Type != 0) {
                     if (!Components)
                        Components = new cComponents;
-                    char buffer[256];
+                    char buffer[Utf8BufSize(256)];
                     Components->SetComponent(Components->NumComponents(), cd->getStreamContent(), cd->getComponentType(), I18nNormalizeLanguageCode(cd->languageCode), cd->description.getText(buffer, sizeof(buffer)));
                     }
                  }
@@ -230,7 +231,7 @@
 
       if (!rEvent) {
          if (ShortEventDescriptor) {
-            char buffer[256];
+            char buffer[Utf8BufSize(256)];
             pEvent->SetTitle(ShortEventDescriptor->name.getText(buffer, sizeof(buffer)));
             pEvent->SetShortText(ShortEventDescriptor->text.getText(buffer, sizeof(buffer)));
             }
@@ -239,7 +240,7 @@
             pEvent->SetShortText(NULL);
             }
          if (ExtendedEventDescriptors) {
-            char buffer[ExtendedEventDescriptors->getMaximumTextLength(": ") + 1];
+            char buffer[Utf8BufSize(ExtendedEventDescriptors->getMaximumTextLength(": ")) + 1];
             pEvent->SetDescription(ExtendedEventDescriptors->getText(buffer, sizeof(buffer), ": "));
             }
          else if (!HasExternalData)
diff -ruN vdr-1.5.2/epg.c vdr-1.5.3/epg.c
--- vdr-1.5.2/epg.c	2006-10-28 11:12:42.000000000 +0200
+++ vdr-1.5.3/epg.c	2007-06-10 14:52:19.000000000 +0200
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.c 1.81 2006/10/28 09:12:42 kls Exp $
+ * $Id: epg.c 1.82 2007/06/10 12:52:19 kls Exp $
  */
 
 #include "epg.h"
@@ -634,6 +634,7 @@
   // data, so let's always convert them to blanks (independent of the setting of EPGBugfixLevel):
   strreplace(title, '\n', ' ');
   strreplace(shortText, '\n', ' ');
+  /* TODO adapt to UTF-8
   // Same for control characters:
   strreplace(title, '\x86', ' ');
   strreplace(title, '\x87', ' ');
@@ -641,6 +642,7 @@
   strreplace(shortText, '\x87', ' ');
   strreplace(description, '\x86', ' ');
   strreplace(description, '\x87', ' ');
+  XXX*/
 }
 
 // --- cSchedule -------------------------------------------------------------
diff -ruN vdr-1.5.2/font.c vdr-1.5.3/font.c
--- vdr-1.5.2/font.c	2007-03-11 10:51:44.000000000 +0100
+++ vdr-1.5.3/font.c	2007-06-09 16:41:27.000000000 +0200
@@ -4,125 +4,296 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: font.c 1.14 2007/03/11 09:51:44 kls Exp $
+ * $Id: font.c 1.15 2007/06/09 14:41:27 kls Exp $
  */
 
-#include "config.h"
-#include <ctype.h>
 #include "font.h"
+#include <ctype.h>
+#include <ft2build.h>
+#include FT_FREETYPE_H
+#include "config.h"
+#include "osd.h"
 #include "tools.h"
 
-#include "fontfix-iso8859-1.c"
-#include "fontosd-iso8859-1.c"
-#include "fontsml-iso8859-1.c"
-
-#include "fontfix-iso8859-2.c"
-#include "fontosd-iso8859-2.c"
-#include "fontsml-iso8859-2.c"
-
-#include "fontfix-iso8859-5.c"
-#include "fontosd-iso8859-5.c"
-#include "fontsml-iso8859-5.c"
-
-#include "fontfix-iso8859-7.c"
-#include "fontosd-iso8859-7.c"
-#include "fontsml-iso8859-7.c"
-
-#include "fontfix-iso8859-9.c"
-#include "fontosd-iso8859-9.c"
-#include "fontsml-iso8859-9.c"
-
-#include "fontfix-iso8859-13.c"
-#include "fontosd-iso8859-13.c"
-#include "fontsml-iso8859-13.c"
-
-#include "fontfix-iso8859-15.c"
-#include "fontosd-iso8859-15.c"
-#include "fontsml-iso8859-15.c"
+// --- cFreetypeFont ---------------------------------------------------------
 
-// --- cFont -----------------------------------------------------------------
+#define KERNING_UNKNOWN  (-10000)
 
-static const void *const FontData[eDvbCodeSize][eDvbFontSize] = {
-  { FontOsd_iso8859_1,  FontFix_iso8859_1,  FontSml_iso8859_1 },
-  { FontOsd_iso8859_2,  FontFix_iso8859_2,  FontSml_iso8859_2 },
-  { FontOsd_iso8859_5,  FontFix_iso8859_5,  FontSml_iso8859_5 },
-  { FontOsd_iso8859_7,  FontFix_iso8859_7,  FontSml_iso8859_7 },
-  { FontOsd_iso8859_9,  FontFix_iso8859_9,  FontSml_iso8859_9 },
-  { FontOsd_iso8859_13, FontFix_iso8859_13, FontSml_iso8859_13 },
-  { FontOsd_iso8859_15, FontFix_iso8859_15, FontSml_iso8859_15 },
+struct tKerning {
+  uint prevSym;
+  int kerning;
+  tKerning(uint PrevSym, int Kerning) { prevSym = PrevSym; kerning = Kerning; }
   };
 
-static const char *FontCode[eDvbCodeSize] = {
-  "iso8859-1",
-  "iso8859-2",
-  "iso8859-5",
-  "iso8859-7",
-  "iso8859-9",
-  "iso8859-13",
-  "iso8859-15",
+class cGlyph : public cListObject {
+private:
+  uint charCode;
+  uchar *bitmap;
+  int advanceX;
+  int advanceY;
+  int left;  ///< The bitmap's left bearing expressed in integer pixels.
+  int top;   ///< The bitmap's top bearing expressed in integer pixels.
+  int width; ///< The number of pixels per bitmap row.
+  int rows;  ///< The number of bitmap rows.
+  int pitch; ///< The pitch's absolute value is the number of bytes taken by one bitmap row, including padding.
+  cVector<tKerning> kerningCache;
+public:
+  cGlyph(uint CharCode, FT_GlyphSlotRec_ *GlyphData);
+  virtual ~cGlyph();
+  uint CharCode(void) const { return charCode; }
+  uchar *Bitmap(void) const { return bitmap; }
+  int AdvanceX(void) const { return advanceX; }
+  int AdvanceY(void) const { return advanceY; }
+  int Left(void) const { return left; }
+  int Top(void) const { return top; }
+  int Width(void) const { return width; }
+  int Rows(void) const { return rows; }
+  int Pitch(void) const { return pitch; }
+  int GetKerningCache(uint PrevSym) const;
+  void SetKerningCache(uint PrevSym, int Kerning);
   };
 
-eDvbCode cFont::code = code_iso8859_1;
-cFont *cFont::fonts[eDvbFontSize] = { NULL };
+cGlyph::cGlyph(uint CharCode, FT_GlyphSlotRec_ *GlyphData)
+{
+  charCode = CharCode;
+  advanceX = GlyphData->advance.x >> 6;
+  advanceY = GlyphData->advance.y >> 6;
+  left = GlyphData->bitmap_left;
+  top = GlyphData->bitmap_top;
+  width = GlyphData->bitmap.width;
+  rows = GlyphData->bitmap.rows;
+  pitch = GlyphData->bitmap.pitch;
+  bitmap = MALLOC(uchar, rows * pitch);
+  memcpy(bitmap, GlyphData->bitmap.buffer, rows * pitch);
+}
 
-cFont::cFont(const void *Data)
+cGlyph::~cGlyph()
 {
-  SetData(Data);
+  free(bitmap);
 }
 
-void cFont::SetData(const void *Data)
+int cGlyph::GetKerningCache(uint PrevSym) const
 {
-  if (Data) {
-     height = ((tCharData *)Data)->height;
-     for (int i = 0; i < NUMCHARS; i++)
-         data[i] = (tCharData *)&((tPixelData *)Data)[(i < 32 ? 0 : i - 32) * (height + 2)];
+  for (int i = kerningCache.Size(); --i > 0; ) {
+      if (kerningCache[i].prevSym == PrevSym)
+         return kerningCache[i].kerning;
+      }
+  return KERNING_UNKNOWN;
+}
+
+void cGlyph::SetKerningCache(uint PrevSym, int Kerning)
+{
+  kerningCache.Append(tKerning(PrevSym, Kerning));
+}
+
+class cFreetypeFont : public cFont {
+private:
+  int height;
+  int bottom;
+  FT_Library library; ///< Handle to library
+  FT_Face face; ///< Handle to face object
+  mutable cList<cGlyph> glyphCacheMonochrome;
+  mutable cList<cGlyph> glyphCacheAntiAliased;
+  int Bottom(void) const { return bottom; }
+  int Kerning(cGlyph *Glyph, uint PrevSym) const;
+  cGlyph* Glyph(uint CharCode, bool AntiAliased = false) const;
+public:
+  cFreetypeFont(const char *Name, int CharHeight);
+  virtual ~cFreetypeFont();
+  virtual int Width(uint c) const;
+  virtual int Width(const char *s) const;
+  virtual int Height(void) const { return height; }
+  virtual void DrawText(cBitmap *Bitmap, int x, int y, const char *s, tColor ColorFg, tColor ColorBg, int Width) const;
+  };
+
+cFreetypeFont::cFreetypeFont(const char *Name, int CharHeight)
+{
+  height = 0;
+  bottom = 0;
+  int error = FT_Init_FreeType(&library);
+  if (!error) {
+     error = FT_New_Face(library, Name, 0, &face);
+     if (!error) {
+        if (face->num_fixed_sizes && face->available_sizes) { // fixed font
+           // TODO what exactly does all this mean?
+           height = face->available_sizes->height;
+           for (uint sym ='A'; sym < 'z'; sym++) { // search for descender for fixed font FIXME
+               FT_UInt glyph_index = FT_Get_Char_Index(face, sym);
+               error = FT_Load_Glyph(face, glyph_index, FT_LOAD_DEFAULT);
+               if (!error) {
+                  error = FT_Render_Glyph(face->glyph, FT_RENDER_MODE_NORMAL);
+                  if (!error) {
+                     if (face->glyph->bitmap.rows-face->glyph->bitmap_top > bottom)
+                        bottom = face->glyph->bitmap.rows-face->glyph->bitmap_top;
+                     }
+                  else
+                     esyslog("ERROR: FreeType: error %d in FT_Render_Glyph", error);
+                  }
+               else
+                  esyslog("ERROR: FreeType: error %d in FT_Load_Glyph", error);
+               }
+           }
+        else {
+           error = FT_Set_Char_Size(face, // handle to face object
+                                    0,    // char_width in 1/64th of points
+                                    CharHeight * 64, // CharHeight in 1/64th of points
+                                    0,    // horizontal device resolution
+                                    0);   // vertical device resolution
+           if (!error) {
+              height = ((face->size->metrics.ascender-face->size->metrics.descender) + 63) / 64;
+              bottom = abs((face->size->metrics.descender - 63) / 64);
+              }
+           else
+              esyslog("ERROR: FreeType: error %d during FT_Set_Char_Size (font = %s)\n", error, Name);
+           }
+        }
+     else
+        esyslog("ERROR: FreeType: load error %d (font = %s)", error, Name);
      }
   else
-     height = 0;
+     esyslog("ERROR: FreeType: initialization error %d (font = %s)", error, Name);
 }
 
-int cFont::Width(const char *s) const
+cFreetypeFont::~cFreetypeFont()
 {
-  int w = 0;
-  while (s && *s)
-        w += Width(*s++);
-  return w;
+  FT_Done_Face(face);
+  FT_Done_FreeType(library);
 }
 
-int cFont::Height(const char *s) const
+int cFreetypeFont::Kerning(cGlyph *Glyph, uint PrevSym) const
 {
-  int h = 0;
-  if (s && *s)
-     h = height; // all characters have the same height!
-  return h;
+  int kerning = 0;
+  if (Glyph && PrevSym) {
+     kerning = Glyph->GetKerningCache(PrevSym);
+     if (kerning == KERNING_UNKNOWN) {
+        FT_Vector delta;
+        FT_UInt glyph_index = FT_Get_Char_Index(face, Glyph->CharCode());
+        FT_UInt glyph_index_prev = FT_Get_Char_Index(face, PrevSym);
+        FT_Get_Kerning(face, glyph_index_prev, glyph_index, FT_KERNING_DEFAULT, &delta);
+        kerning = delta.x / 64;
+        Glyph->SetKerningCache(PrevSym, kerning);
+        }
+     }
+  return kerning;
 }
 
-bool cFont::SetCode(const char *Code)
+cGlyph* cFreetypeFont::Glyph(uint CharCode, bool AntiAliased) const
 {
-  for (int i = 0; i < eDvbCodeSize; i++) {
-      if (strcmp(Code, FontCode[i]) == 0) {
-         SetCode(eDvbCode(i));
-         return true;
-         }
+  // Lookup in cache:
+  cList<cGlyph> *glyphCache = AntiAliased ? &glyphCacheAntiAliased : &glyphCacheMonochrome;
+  for (cGlyph *g = glyphCache->First(); g; g = glyphCache->Next(g)) {
+      if (g->CharCode() == CharCode)
+         return g;
       }
-  return false;
+
+  FT_UInt glyph_index = FT_Get_Char_Index(face, CharCode);
+
+  // Load glyph image into the slot (erase previous one):
+  int error = FT_Load_Glyph(face, glyph_index, FT_LOAD_DEFAULT);
+  if (error)
+     esyslog("ERROR: FreeType: error during FT_Load_Glyph");
+  else {
+#if ((FREETYPE_MAJOR == 2 && FREETYPE_MINOR == 1 && FREETYPE_PATCH >= 7) || (FREETYPE_MAJOR == 2 && FREETYPE_MINOR == 2 && FREETYPE_PATCH <= 1))// TODO workaround for bug? which one?
+     if (AntiAliased || CharCode == 32)
+#else
+     if (AntiAliased)
+#endif
+        error = FT_Render_Glyph(face->glyph, FT_RENDER_MODE_NORMAL);
+     else
+        error = FT_Render_Glyph(face->glyph, FT_RENDER_MODE_MONO);
+     if (error)
+        esyslog("ERROR: FreeType: error during FT_Render_Glyph %d, %d\n", CharCode, glyph_index);
+     else { //new bitmap
+        cGlyph *Glyph = new cGlyph(CharCode, face->glyph);
+        glyphCache->Add(Glyph);
+        return Glyph;
+        }
+     }
+  return NULL;
 }
 
-void cFont::SetCode(eDvbCode Code)
+int cFreetypeFont::Width(uint c) const
 {
-  if (code != Code) {
-     code = Code;
-     for (int i = 0; i < eDvbFontSize; i++) {
-         if (fonts[i])
-            fonts[i]->SetData(FontData[code][i]);
-         }
+  cGlyph *g = Glyph(c, Setup.AntiAlias);
+  return g ? g->AdvanceX() : 0;
+}
+
+int cFreetypeFont::Width(const char *s) const
+{
+  int w = 0;
+  if (s) {
+     uint prevSym = 0;
+     while (*s) {
+           int sl = Utf8CharLen(s);
+           uint sym = Utf8CharGet(s, sl);
+           s += sl;
+           cGlyph *g = Glyph(sym, Setup.AntiAlias);
+           if (g)
+              w += g->AdvanceX() + Kerning(g, prevSym);
+           prevSym = sym;
+           }
+     }
+  return w;
+}
+
+void cFreetypeFont::DrawText(cBitmap *Bitmap, int x, int y, const char *s, tColor ColorFg, tColor ColorBg, int Width) const
+{
+  if (s && height) { // checking height to make sure we actually have a valid font
+     bool AntiAliased = Setup.AntiAlias && Bitmap->Bpp() >= 8;
+     tIndex fg = Bitmap->Index(ColorFg);
+     uint prevSym = 0;
+     while (*s) {
+           int sl = Utf8CharLen(s);
+           uint sym = Utf8CharGet(s, sl);
+           s += sl;
+           cGlyph *g = Glyph(sym, AntiAliased);
+           int kerning = Kerning(g, prevSym);
+           prevSym = sym;
+           uchar *buffer = g->Bitmap();
+           int symWidth = g->Width();
+           if (Width && x + symWidth + g->Left() + kerning - 1 > Width)
+              break; // we don't draw partial characters
+           if (x + symWidth + g->Left() + kerning > 0) {
+              for (int row = 0; row < g->Rows(); row++) {
+                  for (int pitch = 0; pitch < g->Pitch(); pitch++) {
+                      uchar bt = *(buffer + (row * g->Pitch() + pitch));
+                      if (AntiAliased) {
+                         if (bt > 0x00) {
+                            int px = x + pitch + g->Left() + kerning;
+                            int py = y + row + (height - Bottom() - g->Top());
+                            if (bt == 0xFF)
+                               Bitmap->SetIndex(px, py, fg);
+                            else {
+                               tColor bg = (ColorBg != clrTransparent) ? ColorBg : Bitmap->GetColor(px, py);
+                               Bitmap->SetIndex(px, py, Bitmap->Index(Bitmap->Blend(ColorFg, bg, bt)));
+                               }
+                            }
+                         }
+                      else { //monochrome rendering
+                         for (int col = 0; col < 8 && col + pitch * 8 <= symWidth; col++) {
+                             if (bt & 0x80)
+                                Bitmap->SetIndex(x + col + pitch * 8 + g->Left() + kerning, y + row + (height - Bottom() - g->Top()), fg);
+                             bt <<= 1;
+                             }
+                         }
+                      }
+                  }
+              }
+           x += g->AdvanceX() + kerning;
+           if (x > Bitmap->Width() - 1)
+              break;
+           }
      }
 }
 
-void cFont::SetFont(eDvbFont Font, const void *Data)
+// --- cFont -----------------------------------------------------------------
+
+cFont *cFont::fonts[eDvbFontSize] = { NULL };
+
+void cFont::SetFont(eDvbFont Font, const char *Name, int CharHeight)
 {
   delete fonts[Font];
-  fonts[Font] = new cFont(Data ? Data : FontData[code][Font]);
+  fonts[Font] = new cFreetypeFont(*Name == '/' ? Name : *AddDirectory(FONTDIR, Name), CharHeight);
 }
 
 const cFont *cFont::GetFont(eDvbFont Font)
@@ -131,8 +302,13 @@
      Font = fontOsd;
   else if (Setup.UseSmallFont == 2)
      Font = fontSml;
-  if (!fonts[Font])
-     SetFont(Font);
+  if (!fonts[Font]) {
+     switch (Font) {
+       case fontOsd: SetFont(Font, AddDirectory(FONTDIR, Setup.FontOsd), Setup.FontOsdSize); break;
+       case fontSml: SetFont(Font, AddDirectory(FONTDIR, Setup.FontSml), Setup.FontSmlSize); break;
+       case fontFix: SetFont(Font, AddDirectory(FONTDIR, Setup.FontFix), Setup.FontFixSize); break;
+       }
+     }
   return fonts[Font];
 }
 
@@ -176,16 +352,18 @@
   stripspace(text); // strips trailing newlines
 
   for (char *p = text; *p; ) {
-      if (*p == '\n') {
+      int sl = Utf8CharLen(p);
+      uint sym = Utf8CharGet(p, sl);
+      if (sym == '\n') {
          lines++;
          w = 0;
          Blank = Delim = NULL;
          p++;
          continue;
          }
-      else if (isspace(*p))
+      else if (sl == 1 && isspace(sym))
          Blank = p;
-      int cw = Font->Width(*p);
+      int cw = Font->Width(sym);
       if (w + cw > Width) {
          if (Blank) {
             *Blank = '\n';
@@ -214,7 +392,7 @@
          Delim = p;
          Blank = NULL;
          }
-      p++;
+      p += sl;
       }
 }
 
diff -ruN vdr-1.5.2/font.h vdr-1.5.3/font.h
--- vdr-1.5.2/font.h	2007-03-11 10:50:42.000000000 +0100
+++ vdr-1.5.3/font.h	2007-06-10 14:58:54.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: font.h 1.15 2007/03/11 09:50:42 kls Exp $
+ * $Id: font.h 1.16 2007/06/10 12:58:54 kls Exp $
  */
 
 #ifndef __FONT_H
@@ -13,6 +13,10 @@
 #include <stdint.h>
 #include <stdlib.h>
 
+#define MAXFONTNAME 64
+#define MAXFONTSIZE 64
+#define FONTDIR     "/usr/share/fonts/truetype"
+
 enum eDvbFont {
   fontOsd,
   fontFix,
@@ -20,49 +24,35 @@
 #define eDvbFontSize (fontSml + 1)
   };
 
-enum eDvbCode {
-  code_iso8859_1,
-  code_iso8859_2,
-  code_iso8859_5,
-  code_iso8859_7,
-  code_iso8859_9,
-  code_iso8859_13,
-  code_iso8859_15,
-#define eDvbCodeSize (code_iso8859_15 + 1)
-  };
+class cBitmap;
+typedef uint32_t tColor; // see also osd.h
+typedef uint8_t tIndex;
 
 class cFont {
-public:
-  enum { NUMCHARS = 256 };
-  typedef uint32_t tPixelData;
-  struct tCharData {
-    tPixelData width, height;
-    tPixelData lines[1];
-    };
 private:
-  static eDvbCode code;
   static cFont *fonts[];
-  const tCharData *data[NUMCHARS];
-  int height;
 public:
-  cFont(const void *Data);
   virtual ~cFont() {}
-  void SetData(const void *Data);
-  virtual int Width(unsigned char c) const { return data[c]->width; }
-      ///< Returns the width of the given character.
-  virtual int Width(const char *s) const;
-      ///< Returns the width of the given string.
-  virtual int Height(unsigned char c) const { return data[c]->height; }
-      ///< Returns the height of the given character.
-  virtual int Height(const char *s) const;
-      ///< Returns the height of the given string.
-  virtual int Height(void) const { return height; }
-      ///< Returns the height of this font (all characters have the same height).
-  const tCharData *CharData(unsigned char c) const { return data[c]; }
-  static bool SetCode(const char *Code);
-  static void SetCode(eDvbCode Code);
-  static void SetFont(eDvbFont Font, const void *Data = NULL);
+  virtual int Width(uint c) const = 0;
+          ///< Returns the width of the given character in pixel.
+  virtual int Width(const char *s) const = 0;
+          ///< Returns the width of the given string in pixel.
+  virtual int Height(void) const = 0;
+          ///< Returns the height of this font in pixel (all characters have the same height).
+  int Height(const char *s) const { return Height(); }
+          ///< Returns the height of this font in pixel (obsolete, just for backwards compatibilty).
+  virtual void DrawText(cBitmap *Bitmap, int x, int y, const char *s, tColor ColorFg, tColor ColorBg, int Width) const = 0;
+          ///< Draws the given text into the Bitmap at position (x, y) with the given colors.
+          ///< The text will not exceed the given Width (if > 0), and will end with a complete character.
+  static void SetFont(eDvbFont Font, const char *Name, int CharHeight);
+          ///< Sets the given Font to use the font data from the file Name and make its characters
+          ///< CharHeight pixels high.
   static const cFont *GetFont(eDvbFont Font);
+          ///< Gets the given Font, which was previously set by a call to SetFont().
+          ///< If no SetFont() call has been made, the font as defined in the setup is returned.
+          ///< The caller must not use the returned font outside the scope in which
+          ///< it was retrieved by the call to GetFont(), because a call to SetFont()
+          ///< may delete an existing font.
   };
 
 class cTextWrapper {
